extends Control

@onready var toggleButton = $Control/Toggle
@onready var saveButton = $Control/Save
@onready var timeLabel = $Control/Time
@onready var volumeBar = $Control/ProgressBar

var recording = false
var effect : AudioEffectRecord
var idx = AudioServer.get_bus_index("Record")
var outputIDX = AudioServer.get_bus_index("Master")


var timestart = 0


func _ready():
	effect = AudioServer.get_bus_effect(idx, 0)
	




func _process(_delta):
	var volume = db_to_linear(AudioServer.get_bus_peak_volume_left_db(idx, 0))
	volumeBar.value = volume * 100.0
	
	if recording:
		var time = snapped(Time.get_unix_time_from_system() - timestart, 0.01)
		timeLabel.text = str(time)
		
	


func _on_toggle_toggled(toggled_on):
	recording = toggled_on
	effect.set_recording_active(toggled_on)
	
	$mic_input.playing = toggled_on
	AudioServer.set_bus_mute(idx, !toggled_on)
	AudioServer.set_bus_mute(outputIDX, toggled_on)
	
	adjust_visual()
	
	if toggled_on:
		timestart = Time.get_unix_time_from_system()
	else:
		timestart = 0




func adjust_visual():
	if recording:
		saveButton.disabled = true
		toggleButton.text = "Stop"
		
	else:
		saveButton.disabled = false
		toggleButton.text = "Start"








func _on_save_pressed():
	var rec : AudioStreamWAV = effect.get_recording()
	
	var path = OS.get_system_dir(OS.SYSTEM_DIR_DOWNLOADS) + "/" + str(int(Time.get_unix_time_from_system())) + ".wav"
	rec.save_to_wav(path)
	
	OS.alert("Saved audio to path -> " + path, "Saved successfully")
	
	
